Edit

Share via


Items - Bulk Move Items

Move multiple items to a folder. Children items are moved with their parent items. You can't move children items without their parent items.

Note

This API is part of a Preview release and is provided for evaluation and development purposes only. It may change based on feedback and is not recommended for production use.

Permissions

The caller must have contributor or higher role on the workspace.

Required Delegated Scopes

Workspace.ReadWrite.All

Limitations

A single request can't contain more than 50 items.

Microsoft Entra supported identities

This API supports the Microsoft identities listed in this section.

Identity Support
User Yes
Service principal and Managed identities Yes

Interface

POST https://api.fabric.microsoft.com/v1/workspaces/{workspaceId}/items/bulkMove

URI Parameters

Name In Required Type Description
workspaceId
path True

string (uuid)

The workspace ID.

Request Body

Name Required Type Description
items True

string[] (uuid)

The IDs of requested items to move.

targetFolderId

string (uuid)

The destination folder ID. If not provided, the workspace is used as the destination folder.

Responses

Name Type Description
200 OK

MovedItems

Request completed successfully and all the items are moved.

429 Too Many Requests

ErrorResponse

The service rate limit was exceeded. The server returns a Retry-After header indicating, in seconds, how long the client must wait before sending additional requests.

Headers

Retry-After: integer

Other Status Codes

ErrorResponse

Common error codes:

  • ItemNotFound - The requested item was not found.

  • FolderNotFound - Could not find the requested folder.

  • CannotMoveChildOnly - Child item can't be moved without its parent item.

If request failed, no items are moved.

Examples

Bulk move items into folder example
Bulk move items with the workspace as the destination example

Bulk move items into folder example

Sample request

POST https://api.fabric.microsoft.com/v1/workspaces/aaaaaaaa-0000-1111-2222-bbbbbbbbbbbb/items/bulkMove

{
  "targetFolderId": "bbbbbbbb-1111-2222-3333-cccccccccccc",
  "items": [
    "cccccccc-2222-3333-4444-dddddddddddd",
    "dddddddd-3333-4444-5555-eeeeeeeeeeee"
  ]
}

Sample response

{
  "value": [
    {
      "id": "cccccccc-2222-3333-4444-dddddddddddd",
      "displayName": "MyLakehouse",
      "description": "A lakehouse used by the sales team.",
      "type": "Lakehouse",
      "workspaceId": "aaaaaaaa-0000-1111-2222-bbbbbbbbbbbb",
      "folderId": "bbbbbbbb-1111-2222-3333-cccccccccccc"
    },
    {
      "id": "eeeeeeee-4444-5555-6666-ffffffffffff",
      "displayName": "MyLakehouse",
      "description": "A SQL endpoint who is the child of Lakehouse",
      "type": "SQLEndpoint",
      "workspaceId": "aaaaaaaa-0000-1111-2222-bbbbbbbbbbbb",
      "folderId": "bbbbbbbb-1111-2222-3333-cccccccccccc"
    },
    {
      "id": "ffffffff-5555-6666-7777-aaaaaaaaaaaa",
      "displayName": "MyLakehouse",
      "description": "A Semantic model who is the child of SQLEndpoint",
      "type": "SemanticModel",
      "workspaceId": "aaaaaaaa-0000-1111-2222-bbbbbbbbbbbb",
      "folderId": "bbbbbbbb-1111-2222-3333-cccccccccccc"
    },
    {
      "id": "dddddddd-3333-4444-5555-eeeeeeeeeeee",
      "displayName": "Notebook",
      "description": "A notebook for refining year 2024 sales data analysis through machine learning algorithms.",
      "type": "SynapseNotebook",
      "workspaceId": "aaaaaaaa-0000-1111-2222-bbbbbbbbbbbb",
      "folderId": "bbbbbbbb-1111-2222-3333-cccccccccccc"
    }
  ]
}

Bulk move items with the workspace as the destination example

Sample request

POST https://api.fabric.microsoft.com/v1/workspaces/aaaaaaaa-0000-1111-2222-bbbbbbbbbbbb/items/bulkMove

{
  "items": [
    "cccccccc-2222-3333-4444-dddddddddddd",
    "dddddddd-3333-4444-5555-eeeeeeeeeeee"
  ]
}

Sample response

{
  "value": [
    {
      "id": "cccccccc-2222-3333-4444-dddddddddddd",
      "displayName": "MyLakehouse",
      "description": "A lakehouse used by the sales team.",
      "type": "Lakehouse",
      "workspaceId": "aaaaaaaa-0000-1111-2222-bbbbbbbbbbbb"
    },
    {
      "id": "eeeeeeee-4444-5555-6666-ffffffffffff",
      "displayName": "MyLakehouse",
      "description": "A SQL endpoint who is the child of Lakehouse",
      "type": "SQLEndpoint",
      "workspaceId": "aaaaaaaa-0000-1111-2222-bbbbbbbbbbbb"
    },
    {
      "id": "ffffffff-5555-6666-7777-aaaaaaaaaaaa",
      "displayName": "MyLakehouse",
      "description": "A Semantic model who is the child of SQLEndpoint",
      "type": "SemanticModel",
      "workspaceId": "aaaaaaaa-0000-1111-2222-bbbbbbbbbbbb"
    },
    {
      "id": "dddddddd-3333-4444-5555-eeeeeeeeeeee",
      "displayName": "Notebook",
      "description": "A notebook for refining year 2024 sales data analysis through machine learning algorithms.",
      "type": "SynapseNotebook",
      "workspaceId": "aaaaaaaa-0000-1111-2222-bbbbbbbbbbbb"
    }
  ]
}

Definitions

Name Description
BulkMoveItemsRequest

Bulk move items request.

EntireTenantPrincipal

Represents a tenant principal

ErrorRelatedResource

The error related resource details object.

ErrorResponse

The error response.

ErrorResponseDetails

The error response details.

GroupDetails

Group specific details. Applicable when the principal type is Group.

GroupPrincipal

Represents a security group.

GroupType

The type of the group. Additional group types may be added over time.

Item

An item object.

ItemTag

Represents a tag applied on an item.

ItemType

The type of the item. Additional item types may be added over time.

MovedItems
PrincipalType

The type of the principal. Additional principal types may be added over time.

SensitivityLabel

Represents a sensitivity label applied to an item.

ServicePrincipalDetails

Service principal specific details. Applicable when the principal type is ServicePrincipal.

ServicePrincipalPrincipal

Represents a Microsoft Entra service principal.

ServicePrincipalProfileDetails

Service principal profile details. Applicable when the principal type is ServicePrincipalProfile.

ServicePrincipalProfilePrincipal

Represents a service principal profile.

UserDetails

User principal specific details. Applicable when the principal type is User.

UserPrincipal

Represents a Microsoft Entra user principal.

BulkMoveItemsRequest

Bulk move items request.

Name Type Description
items

string[] (uuid)

The IDs of requested items to move.

targetFolderId

string (uuid)

The destination folder ID. If not provided, the workspace is used as the destination folder.

EntireTenantPrincipal

Represents a tenant principal

Name Type Description
displayName

string

The principal's display name.

id

string (uuid)

The principal's ID.

type string:

EntireTenant

The type of the principal. Additional principal types may be added over time.

ErrorRelatedResource

The error related resource details object.

Name Type Description
resourceId

string

The resource ID that's involved in the error.

resourceType

string

The type of the resource that's involved in the error.

ErrorResponse

The error response.

Name Type Description
errorCode

string

A specific identifier that provides information about an error condition, allowing for standardized communication between our service and its users.

message

string

A human readable representation of the error.

moreDetails

ErrorResponseDetails[]

List of additional error details.

relatedResource

ErrorRelatedResource

The error related resource details.

requestId

string (uuid)

ID of the request associated with the error.

ErrorResponseDetails

The error response details.

Name Type Description
errorCode

string

A specific identifier that provides information about an error condition, allowing for standardized communication between our service and its users.

message

string

A human readable representation of the error.

relatedResource

ErrorRelatedResource

The error related resource details.

GroupDetails

Group specific details. Applicable when the principal type is Group.

Name Type Description
groupType

GroupType

The type of the group. Additional group types may be added over time.

GroupPrincipal

Represents a security group.

Name Type Description
displayName

string

The principal's display name.

groupDetails

GroupDetails

Group specific details. Applicable when the principal type is Group.

id

string (uuid)

The principal's ID.

type string:

Group

The type of the principal. Additional principal types may be added over time.

GroupType

The type of the group. Additional group types may be added over time.

Value Description
Unknown

Principal group type is unknown.

SecurityGroup

Principal is a security group.

DistributionList

Principal is a distribution list.

Item

An item object.

Name Type Description
defaultIdentity Principal:

The item's default identity.

description

string

The item description.

displayName

string

The item display name.

folderId

string (uuid)

The folder ID.

id

string (uuid)

The item ID.

sensitivityLabel

SensitivityLabel

The item sensitivity label.

tags

ItemTag[]

List of applied tags.

type

ItemType

The item type.

workspaceId

string (uuid)

The workspace ID.

ItemTag

Represents a tag applied on an item.

Name Type Description
displayName

string

The name of the tag.

id

string (uuid)

The tag ID.

ItemType

The type of the item. Additional item types may be added over time.

Value Description
Dashboard

PowerBI dashboard.

Report

PowerBI report.

SemanticModel

PowerBI semantic model.

PaginatedReport

PowerBI paginated report.

Datamart

PowerBI datamart.

Lakehouse

A lakehouse.

Eventhouse

An eventhouse.

Environment

An environment.

KQLDatabase

A KQL database.

KQLQueryset

A KQL queryset.

KQLDashboard

A KQL dashboard.

DataPipeline

A data pipeline.

Notebook

A notebook.

SparkJobDefinition

A spark job definition.

MLExperiment

A machine learning experiment.

MLModel

A machine learning model.

Warehouse

A warehouse.

Eventstream

An eventstream.

SQLEndpoint

An SQL endpoint.

MirroredWarehouse

A mirrored warehouse.

MirroredDatabase

A mirrored database.

Reflex

A Reflex.

GraphQLApi

An API for GraphQL item.

MountedDataFactory

A MountedDataFactory.

SQLDatabase

A SQLDatabase.

CopyJob

A Copy job.

VariableLibrary

A VariableLibrary.

Dataflow

A Dataflow.

ApacheAirflowJob

An ApacheAirflowJob.

WarehouseSnapshot

A Warehouse snapshot.

DigitalTwinBuilder

A DigitalTwinBuilder.

DigitalTwinBuilderFlow

A Digital Twin Builder Flow.

MirroredAzureDatabricksCatalog

A mirrored azure databricks catalog.

Map

A Map.

AnomalyDetector

An Anomaly Detector.

UserDataFunction

A User Data Function.

GraphModel

A GraphModel.

GraphQuerySet

A Graph QuerySet.

SnowflakeDatabase

A Snowflake Database to store Iceberg tables created from Snowflake account.

OperationsAgent

A OperationsAgent.

CosmosDBDatabase

A Cosmos DB Database.

Ontology

An Ontology.

EventSchemaSet

An EventSchemaSet.

DataAgent

A DataAgent.

MovedItems

Name Type Description
value

Item[]

A list of items.

PrincipalType

The type of the principal. Additional principal types may be added over time.

Value Description
User

Principal is a Microsoft Entra user principal.

ServicePrincipal

Principal is a Microsoft Entra service principal.

Group

Principal is a security group.

ServicePrincipalProfile

Principal is a service principal profile.

EntireTenant

Principal represents all tenant users.

SensitivityLabel

Represents a sensitivity label applied to an item.

Name Type Description
id

string (uuid)

The sensitivity label ID.

ServicePrincipalDetails

Service principal specific details. Applicable when the principal type is ServicePrincipal.

Name Type Description
aadAppId

string (uuid)

The service principal's Microsoft Entra AppId.

ServicePrincipalPrincipal

Represents a Microsoft Entra service principal.

Name Type Description
displayName

string

The principal's display name.

id

string (uuid)

The principal's ID.

servicePrincipalDetails

ServicePrincipalDetails

Service principal specific details. Applicable when the principal type is ServicePrincipal.

type string:

ServicePrincipal

The type of the principal. Additional principal types may be added over time.

ServicePrincipalProfileDetails

Service principal profile details. Applicable when the principal type is ServicePrincipalProfile.

Name Type Description
parentPrincipal Principal:

The service principal profile's parent principal.

ServicePrincipalProfilePrincipal

Represents a service principal profile.

Name Type Description
displayName

string

The principal's display name.

id

string (uuid)

The principal's ID.

servicePrincipalProfileDetails

ServicePrincipalProfileDetails

Service principal profile details. Applicable when the principal type is ServicePrincipalProfile.

type string:

ServicePrincipalProfile

The type of the principal. Additional principal types may be added over time.

UserDetails

User principal specific details. Applicable when the principal type is User.

Name Type Description
userPrincipalName

string

The user principal name.

UserPrincipal

Represents a Microsoft Entra user principal.

Name Type Description
displayName

string

The principal's display name.

id

string (uuid)

The principal's ID.

type string:

User

The type of the principal. Additional principal types may be added over time.

userDetails

UserDetails

User principal specific details. Applicable when the principal type is User.